/*
 * thermald - pid.h
 *
 * Copyright (C) 2009  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __PID_H
#define __PID_H

struct pid {
	/* parameters */
	double k;
	double Ti;
	double Td;
	double N;
	double Tp;

	/* run-time */
	double e1;		/* e(i-1) */
	double e2;		/* e(i-2) */
	double u;		/* u(i-1) */
};

int pid_init(struct pid *pid, double k, double Ti, double Td, double N);
int pid_set_interval(struct pid *pid, double Tp);
int pid_step(struct pid *pid, double e);
double pid_output(struct pid *pid);

#endif
